#!/usr/bin/env python3
import os
import glob
import sys
import time


def read_temp_raw():
    try:
        f = open(device_file, 'r')
        lines = f.readlines()
        f.close()
        return lines
    except Exception as ex:
        pass


def read_temp():
    lines = read_temp_raw()
    try:
        if lines[0].strip()[-3:] == 'YES':
            # Got 'YES' status, attempt to read temperature
            equals_pos = lines[1].find('t=')
            if equals_pos != -1:
                # temperature value found, convert to numeric value for C and F
                temp_string = lines[1][equals_pos+2:]
                temp_c = float(temp_string) / 1000.0
                temp_f = temp_c * 1.8 + 32.0
                return temp_c, temp_f
    except Exception:
        pass


os.system('modprobe w1-gpio')
os.system('modprobe w1-therm')

temp_sensor_dir = '/sys/bus/w1/devices/'

try:
    device_folder = glob.glob(temp_sensor_dir + '28*')[0]
    device_file = device_folder + '/w1_slave'
except Exception as ex:
    pass
    # print('Cannot connect to sensor. Exception details: ' + str(ex))

if __name__ == '__main__':
    while True:
        temps = read_temp()
        if temps is not None:
            print('Temperature is {} Celsius / {} Fahrenheit'.format(temps[0],
                  temps[1]))
        else:
            print('Temperature could not be read')
        time.sleep(1)
